package trashplace.btTest1;

import android.app.Activity;
import android.content.Context;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.os.Bundle;
import android.util.Log;
import android.view.Display;
import android.view.View;
import android.view.WindowManager;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.TextView;


public class Graph extends Activity implements OnClickListener {

	//	@Override
	//	protected void onCreate(Bundle savedInstanceState) {
	//		super.onCreate(savedInstanceState);
	//		setContentView(R.layout.graph);
	//		
	//	}

	static Bar					BarRC1, BarRC2, BarRC3, BarRC4, BarRC5, BarRC6, BarRC7, BarRC8;
	static Bar					BarGyroX, BarGyroY, BarGyroZ;
	static Bar					BarMotor0, BarMotor1, BarMotor2, BarMotor3, BarMotor4, BarMotor5;
	LinearLayout				graphRCLayout;
	LinearLayout				graphGyroLayout;
	LinearLayout				graphMotorLayout;
	Button						bGraphRC;
	Button						bGraphMotors;
	Button						bGraphRefresh;
	static TextView					tvGraphCycletime;

	public static mwcParser		mMWCParser;


	public static final String	TAG	= "Graph";


	/** Called when the activity is first created. */
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		BarRC1 = new Bar(this);
		BarRC2 = new Bar(this);
		BarRC3 = new Bar(this);
		BarRC4 = new Bar(this);
		BarRC5 = new Bar(this);
		BarRC6 = new Bar(this);
		BarRC7 = new Bar(this);
		BarRC8 = new Bar(this);
		BarRC1.setRange(950, 2050);
		BarRC2.setRange(950, 2050);
		BarRC3.setRange(950, 2050);
		BarRC4.setRange(950, 2050);
		BarRC5.setRange(950, 2050);
		BarRC6.setRange(950, 2050);
		BarRC7.setRange(950, 2050);
		BarRC8.setRange(950, 2050);

		BarGyroX = new Bar(this);
		BarGyroY = new Bar(this);
		BarGyroZ = new Bar(this);
		BarGyroX.setRange(-50, 50);
		BarGyroY.setRange(-50, 50);
		BarGyroZ.setRange(-50, 50);

		BarMotor0 = new Bar(this);
		BarMotor1 = new Bar(this);
		BarMotor2 = new Bar(this);
		BarMotor3 = new Bar(this);
		BarMotor4 = new Bar(this);
		BarMotor5 = new Bar(this);
		BarMotor0.setRange(1000, 2000);
		BarMotor1.setRange(1000, 2000);
		BarMotor2.setRange(1000, 2000);
		BarMotor3.setRange(1000, 2000);
		BarMotor4.setRange(1000, 2000);
		BarMotor5.setRange(1000, 2000);

		mMWCParser = btTest1Main.mMWCParser;
		setContentView(R.layout.graph);

		bGraphRC = (Button) findViewById(R.id.bGraphRC);
		bGraphMotors = (Button) findViewById(R.id.bGraphMotors);
		bGraphRefresh = (Button) findViewById(R.id.bGraphRefresh);
		graphRCLayout = (LinearLayout) findViewById(R.id.graphRCLayout);
		graphGyroLayout = (LinearLayout) findViewById(R.id.graphGyroLayout);
		graphMotorLayout = (LinearLayout) findViewById(R.id.graphMotorLayout);
		tvGraphCycletime = (TextView) findViewById(R.id.tvGraphCycletime);

		bGraphRefresh.setOnClickListener(this);
		bGraphMotors.setOnClickListener(this);
		bGraphRC.setOnClickListener(this);

		graphRCLayout.addView(BarRC1);
		graphRCLayout.addView(BarRC2);
		graphRCLayout.addView(BarRC3);
		graphRCLayout.addView(BarRC4);
		graphRCLayout.addView(BarRC5);
		graphRCLayout.addView(BarRC6);
		graphRCLayout.addView(BarRC7);
		graphRCLayout.addView(BarRC8);

		graphGyroLayout.addView(BarGyroX);
		graphGyroLayout.addView(BarGyroY);
		graphGyroLayout.addView(BarGyroZ);

		graphMotorLayout.addView(BarMotor0);
		graphMotorLayout.addView(BarMotor1);
		graphMotorLayout.addView(BarMotor2);
		graphMotorLayout.addView(BarMotor3);
		graphMotorLayout.addView(BarMotor4);
		graphMotorLayout.addView(BarMotor5);

		updateGUI();

	}

	@Override
	public void onClick(View v) {
		switch (v.getId()) {
		case R.id.bGraphRefresh:
			if (btTest1Main.cbReqParams.isChecked()) {
				btTest1Main.cbReqParams.setChecked(false);
			} else {
				btTest1Main.cbReqParams.setChecked(true);
				btTest1Main.requestData();
			}
			break;
		case R.id.bGraphRC:
			if (graphRCLayout.getVisibility() == View.VISIBLE) {
				Log.d(TAG, "RC visible => set invisible.");
				graphRCLayout.setVisibility(View.GONE);
			} else {
				Log.d(TAG, "RC invisible => set visible.");
				graphRCLayout.setVisibility(View.VISIBLE);
			}
			break;
		case R.id.bGraphMotors:
			if (graphMotorLayout.getVisibility() == View.VISIBLE) {
				Log.d(TAG, "RC visible => set invisible.");
				graphMotorLayout.setVisibility(View.GONE);
			} else {
				Log.d(TAG, "RC invisible => set visible.");
				graphMotorLayout.setVisibility(View.VISIBLE);
			}
			break;
		}
	}

	public static void updateGUI() {
		Log.d(TAG, "UpdateGUI: GyroData: " + String.format("%d/%d/%d",
				mMWCParser.gyroData[0], mMWCParser.gyroData[1], mMWCParser.gyroData[2]));

		BarRC1.setValue(mMWCParser.rcHysteresis[0]);
		BarRC2.setValue(mMWCParser.rcHysteresis[1]);
		BarRC3.setValue(mMWCParser.rcHysteresis[2]);
		BarRC4.setValue(mMWCParser.rcHysteresis[3]);
		BarRC5.setValue(mMWCParser.rcHysteresis[4]);
		BarRC6.setValue(mMWCParser.rcHysteresis[5]);
		BarRC7.setValue(mMWCParser.rcHysteresis[6]);
		BarRC8.setValue(mMWCParser.rcHysteresis[7]);

		BarGyroX.setValue(mMWCParser.gyroData[0]);
		BarGyroY.setValue(mMWCParser.gyroData[1]);
		BarGyroZ.setValue(mMWCParser.gyroData[2]);

		BarMotor0.setValue(mMWCParser.motor[0]);
		BarMotor1.setValue(mMWCParser.motor[1]);
		BarMotor2.setValue(mMWCParser.motor[2]);
		BarMotor3.setValue(mMWCParser.motor[3]);
		BarMotor4.setValue(mMWCParser.motor[4]);
		BarMotor5.setValue(mMWCParser.motor[5]);
		
		tvGraphCycletime.setText(String.format("CycleTime: %d", mMWCParser.cycleTime));

	}

	private class Bar extends View {

		// for now: hardcoded bar width (in pixels)
		int	WIDTH		= 300;

		// dimensions of the bar
		int					w			= 10;
		int					h			= 25;
		int					offsY		= 10;
		int					offsX		= 90;

		public int			minValue	= 0;
		public int			maxValue	= 100;
		int					value		= 40;

		public Bar(Context context) {
			super(context);

		}

		@Override
		protected void onDraw(Canvas canvas) {
			super.onDraw(canvas);

			Paint paint = new Paint();
			paint.setStyle(Paint.Style.FILL);
			paint.setTextSize(25);

			// make the entire canvas black
			canvas.drawColor(Color.BLACK);

			//paint.setAntiAlias(false);
			paint.setColor(Color.YELLOW);

			int lr, lb, lt, ll;

			w = (int) (((float) value - minValue) / ((float) maxValue - minValue) * (WIDTH-offsX));
			ll = offsX;
			lt = offsY;
			lr = w + offsX;
			lb = offsY + h;

			// draw bar
			canvas.drawRect(ll, lt, lr, lb, paint);

			// draw numeric value
			canvas.drawText(String.format("%d", value), 10, 25, paint);

		}

		public void setValue(int val) {
			if (val >= minValue & val <= maxValue) {
				value = val;
				invalidate();
			}
		}

		public void setRange(int min, int max) {
			minValue = min;
			maxValue = max;
		}

		@Override
		protected void onMeasure(int widthMeasureSpec, int heightMeasureSpec) {
			WindowManager wm = getWindowManager();
			Display d = wm.getDefaultDisplay();
			WIDTH = d.getWidth();
			//Log.d(TAG, String.format("display width: %d", WIDTH));
			
			//super.onMeasure(widthMeasureSpec, heightMeasureSpec);
			setMeasuredDimension(WIDTH, h + 20);
		}
	}

}
