package trashplace.btTest1;

import android.util.Log;

// Cotainer that stores Data received via BT
public class dataContainer {

	byte[]	buffer; // 1k buffer for incoming data.
	int		pos;	// number bytes in buffer; byte at pos is empty and can be used.


	// Constructor
	public dataContainer(int size) {
		super();
		buffer = new byte[size];
	}

	// wipe buffer, reset pos counter
	public void clear() {
		int i;
		synchronized (this) {
			for (i = 0; i < buffer.length; i++) {
				buffer[i] = 0;
			}
		}
		pos = 0;
	}

	/**
	 * 
	 * store new data in buffer
	 * 
	 * @param aBuffer
	 *            buffer to be appended
	 * @param length
	 *            length of data in given buffer
	 * @return length of stored buffer
	 */
	public int append(byte[] aBuffer, int length) {
		int i;

		// TODO: make sure that read data doesn't exceed buffer size
		
		synchronized (this) {
			for (i = 0; i < length; i++) {
				buffer[pos + i] = aBuffer[i];
			}
			pos += length;
		}
		//Log.d("dataContainer", "Data appended. Pos: " + pos);
		return pos;
	}

	// return part of buffer.
	public byte[] read(int pos, int length) {
		byte[] result;
		int llength;

		synchronized (this) {
			if (length > pos) {
				llength = pos;
			} else {
				llength = length;
			}

			result = new byte[llength];

			int i;
			for (i = 0; i < llength; i++) {
				result[i] = buffer[pos + i];
			}
		}
		
		return result;
	}

	// return complete buffer.
	public byte[] getBuffer() {
		byte[] result;

		synchronized (this) {
			result = new byte[pos];

			int i;
			for (i = 0; i < pos; i++) {
				result[i] = buffer[i];
			}
		}
		return result;
	}

	// return length of buffer.
	public int getLength() {
		return pos;
	}
}
